| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Private Member Functions | Private Attributes | List of all members
CPUCrunchSvc Class Reference

`#include <src/CPUCrunchSvc/CPUCrunchSvc.h>`

Inheritance diagram for CPUCrunchSvc:
[legend]
Collaboration diagram for CPUCrunchSvc:
[legend]

## Public Member Functions
| CPUCrunchSvc (const std::string &name, ISvcLocator *svc)
virtual StatusCode | initialize () override
std::chrono::milliseconds | crunch_for (const std::chrono::milliseconds &crunchtime) const override
Public Member Functions inherited from extends< Service, ICPUCrunchSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Private Member Functions
void | calibrate ()
unsigned int | getNCaliIters (std::chrono::microseconds runtime) const
void | findPrimes (unsigned int) const

## Private Attributes
std::vector< unsigned int > | m_times_vect
Gaudi::Property< std::vector< unsigned int > > | m_niters_vect
Gaudi::Property< bool > | m_shortCalib {this, "shortCalib", false, "Enable coarse grained calibration"}
Gaudi::Property< unsigned int > | m_minCalibTime
Gaudi::Property< int > | m_numCalibRuns {this, "numCalibRuns", 1, "Number of times to do calibration run"}
Gaudi::Property< float > | m_corrFact

## Additional Inherited Members
Public Types inherited from extends< Service, ICPUCrunchSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 13 of file CPUCrunchSvc.h.

## Constructor & Destructor Documentation

## ◆ CPUCrunchSvc()

CPUCrunchSvc::CPUCrunchSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Definition at line 19 of file CPUCrunchSvc.cpp.

19 : base_class( name, svc ) {}
extends< Service, ICPUCrunchSvc >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274

## Member Function Documentation

## ◆ calibrate()

void CPUCrunchSvc::calibrate | ( |  | ) |
| private

Definition at line 42 of file CPUCrunchSvc.cpp.

42 {
43 if ( m_niters_vect.value().size() == 0 ) {
44 m_niters_vect = {0, 500, 600, 700, 800, 1000, 1300, 1600, 2000, 2300,
45 2600, 3000, 3300, 3500, 3900, 4200, 5000, 6000, 8000, 10000,
46 12000, 15000, 17000, 20000, 25000, 30000, 35000, 40000, 50000, 60000};
47 if ( !m_shortCalib ) {
48 m_niters_vect.value().push_back( 80000 );
49 m_niters_vect.value().push_back( 100000 );
50 m_niters_vect.value().push_back( 150000 );
51 m_niters_vect.value().push_back( 200000 );
52 }
53 }
54
55 if ( m_niters_vect.value().at( 0 ) != 0 ) {
56 warning() << "NIterationsVect[0]= " << m_niters_vect.value().at( 0 ) << " but needs to be zero. resetting it."
57 << endmsg;
58 m_niters_vect.value().at( 0 ) = 0;
59 }
60
61 m_times_vect.resize( m_niters_vect.value().size() );
62 m_times_vect.at( 0 ) = 0;
63
64 const unsigned int minCalibTime_us = m_minCalibTime * 1000;
65
66 // warm it up by doing 20k iterations
67 findPrimes( 20000 );
68
69 for ( int irun = 0; irun < m_numCalibRuns; ++irun ) {
70
71 debug() << "Starting calibration run " << irun + 1 << " ..." << endmsg;
72 for ( unsigned int i = 1; i < m_niters_vect.value().size(); ++i ) {
73 unsigned int niters = m_niters_vect.value().at( i );
74 unsigned int trials = 30;
75 do {
76 auto start_cali = tbb::tick_count::now();
77 findPrimes( niters );
78 auto stop_cali = tbb::tick_count::now();
79 auto deltat = ( stop_cali - start_cali ).seconds();
80 m_times_vect.at( i ) = deltat * 1000000; // in microseconds
81 debug() << " Calibration: # iters = " << niters << " => " << m_times_vect.at( i ) << " us" << endmsg;
82 trials--;
83 } while ( trials > 0 && m_times_vect.at( i ) < m_times_vect.at( i - 1 ) ); // make sure that they are monotonic
84
85 if ( i == m_niters_vect.value().size() - 1 && minCalibTime_us != 0 ) {
86 if ( m_times_vect.at( i ) < minCalibTime_us ) {
87 debug() << " increasing calib vect with " << int( m_niters_vect.value().back() * 1.2 )
88 << " iterations to reach min calib time of " << m_minCalibTime.value() << " ms " << endmsg;
89 m_niters_vect.value().push_back( int( m_niters_vect.value().back() * 1.2 ) );
90 m_times_vect.push_back( 0. );
91 }
92 }
93 }
94 }
95 if ( m_corrFact != 1. ) {
96 debug() << "Adjusting times with correction factor " << m_corrFact.value() << endmsg;
97 for ( auto& t : m_times_vect ) { t = t * m_corrFact; }
98 }
99 debug() << "Calibration finished!" << endmsg;
100 }
CPUCrunchSvc::m_minCalibTime
Gaudi::Property< unsigned int > m_minCalibTime
Definition: CPUCrunchSvc.h:35
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:101
std::vector::resize
T resize(T... args)
std::vector::at
T at(T... args)
std::vector::push_back
T push_back(T... args)
CPUCrunchSvc::m_shortCalib
Gaudi::Property< bool > m_shortCalib
Definition: CPUCrunchSvc.h:34
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
CPUCrunchSvc::m_corrFact
Gaudi::Property< float > m_corrFact
Definition: CPUCrunchSvc.h:38
CPUCrunchSvc::m_numCalibRuns
Gaudi::Property< int > m_numCalibRuns
Definition: CPUCrunchSvc.h:37
CPUCrunchSvc::findPrimes
void findPrimes(unsigned int) const
Definition: CPUCrunchSvc.cpp:142
CPUCrunchSvc::m_times_vect
std::vector< unsigned int > m_times_vect
Definition: CPUCrunchSvc.h:30
CPUCrunchSvc::m_niters_vect
Gaudi::Property< std::vector< unsigned int > > m_niters_vect
Definition: CPUCrunchSvc.h:32
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ crunch_for()

std::chrono::milliseconds CPUCrunchSvc::crunch_for | ( | const std::chrono::milliseconds & | crunchtime | ) | const
| override

Definition at line 194 of file CPUCrunchSvc.cpp.

194 {
195
196 const unsigned int niters = getNCaliIters( crunchtime );
197
198 auto start_cali = tbb::tick_count::now();
199 findPrimes( niters );
200 auto stop_cali = tbb::tick_count::now();
201
202 std::chrono::milliseconds actual( int( 1000 * ( stop_cali - start_cali ).seconds() ) );
203
204 DEBUG_MSG << "crunch for " << crunchtime.count() << " ms == " << niters << " iter. actual time: " << actual.count()
205 << " ms. ratio: " << float( actual.count() ) / crunchtime.count() << endmsg;
206
207 return actual;
208 }
std::chrono::milliseconds
CPUCrunchSvc::getNCaliIters
unsigned int getNCaliIters(std::chrono::microseconds runtime) const
Definition: CPUCrunchSvc.cpp:104
std::chrono::milliseconds::count
T count(T... args)
CPUCrunchSvc::findPrimes
void findPrimes(unsigned int) const
Definition: CPUCrunchSvc.cpp:142
DEBUG_MSG
#define DEBUG_MSG
Definition: CPUCrunchSvc.cpp:12
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ findPrimes()

void CPUCrunchSvc::findPrimes | ( | unsigned int | n_iterations | ) | const
| private

Definition at line 142 of file CPUCrunchSvc.cpp.

142 {
143 // Flag to trigger the allocation
144 bool is_prime;
145
146 // Let's prepare the material for the allocations
147 unsigned int primes_size = 1;
148 unsigned long* primes = new unsigned long[primes_size];
149 primes[0] = 2;
150
151 unsigned long i = 2;
152
153 // Loop on numbers
154 for ( unsigned long int iiter = 0; iiter < n_iterations; iiter++ ) {
155 // Once at max, it returns to 0
156 i += 1;
157
158 // Check if it can be divided by the smaller ones
159 is_prime = true;
160 for ( unsigned long j = 2; j < i && is_prime; ++j ) {
161 if ( i % j == 0 ) is_prime = false;
162 } // end loop on numbers < than tested one
163
164 if ( is_prime ) {
165 // copy the array of primes (INEFFICIENT ON PURPOSE!)
166 unsigned int new_primes_size = 1 + primes_size;
167 unsigned long* new_primes = new unsigned long[new_primes_size];
168
169 for ( unsigned int prime_index = 0; prime_index < primes_size; prime_index++ ) {
170 new_primes[prime_index] = primes[prime_index];
171 }
172 // attach the last prime
173 new_primes[primes_size] = i;
174
175 // Update primes array
176 delete[] primes;
177 primes = new_primes;
178 primes_size = new_primes_size;
179 } // end is prime
180
181 } // end of while loop
182
183 // Fool Compiler optimisations:
184 for ( unsigned int prime_index = 0; prime_index < primes_size; prime_index++ )
185 if ( primes[prime_index] == 4 )
186 debug() << "This does never happen, but it's necessary too fool aggressive compiler optimisations!" << endmsg;
187
188 delete[] primes;
189 }
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ getNCaliIters()

unsigned int CPUCrunchSvc::getNCaliIters | ( | std::chrono::microseconds | runtime | ) | const
| private

Definition at line 104 of file CPUCrunchSvc.cpp.

104 {
105
106 unsigned int smaller_i = 0;
107 double time = 0.;
108 bool found = false;
109 double corrRuntime = runtime.count(); // * m_corrFact;
110 // We know that the first entry is 0, so we start to iterate from 1
111 for ( unsigned int i = 1; i < m_times_vect.size(); i++ ) {
112 time = m_times_vect.at( i );
113 if ( time > corrRuntime ) {
114 smaller_i = i - 1;
115 found = true;
116 break;
117 }
118 }
119
120 // Case 1: we are outside the interpolation range, we take the last 2 points
121 if ( not found ) smaller_i = m_times_vect.size() - 2;
122
123 // Case 2: we maeke a linear interpolation
124 // y=mx+q
125 const auto x0 = m_times_vect.at( smaller_i );
126 const auto x1 = m_times_vect.at( smaller_i + 1 );
127 const auto y0 = m_niters_vect.value().at( smaller_i );
128 const auto y1 = m_niters_vect.value().at( smaller_i + 1 );
129 const double m = (double)( y1 - y0 ) / (double)( x1 - x0 );
130 const double q = y0 - m * x0;
131
132 const unsigned int nCaliIters = m * corrRuntime + q;
133
134 VERBOSE_MSG << "x0: " << x0 << " x1: " << x1 << " y0: " << y0 << " y1: " << y1 << " m: " << m << " q: " << q
135 << " itr: " << nCaliIters << endmsg;
136
137 return nCaliIters;
138 }
plotSpeedupsPyRoot.time
def time
Definition: plotSpeedupsPyRoot.py:152
std::vector::at
T at(T... args)
VERBOSE_MSG
#define VERBOSE_MSG
Definition: CPUCrunchSvc.cpp:15
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:92
std::chrono::microseconds::count
T count(T... args)
std::vector::size
T size(T... args)
CPUCrunchSvc::m_times_vect
std::vector< unsigned int > m_times_vect
Definition: CPUCrunchSvc.h:30
CPUCrunchSvc::m_niters_vect
Gaudi::Property< std::vector< unsigned int > > m_niters_vect
Definition: CPUCrunchSvc.h:32
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ initialize()

StatusCode CPUCrunchSvc::initialize | ( |  | ) |
| override virtual

Definition at line 23 of file CPUCrunchSvc.cpp.

23 {
24 debug() << "initialize" << endmsg;
25
26 if ( base_class::initialize().isFailure() ) {
27 error() << "Error initializing base class" << endmsg;
28 return StatusCode::FAILURE;
29 }
30
31 calibrate();
32
33 return StatusCode::SUCCESS;
34 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
CPUCrunchSvc::calibrate
void calibrate()
Definition: CPUCrunchSvc.cpp:42
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## Member Data Documentation

## ◆ m_corrFact

Gaudi::Property<float> CPUCrunchSvc::m_corrFact
| private

Initial value:
{this, "calibCorrectionFactor", 1.,
"Calibration correction factor to take into account things like turbo boost"}

Definition at line 38 of file CPUCrunchSvc.h.

## ◆ m_minCalibTime

Gaudi::Property<unsigned int> CPUCrunchSvc::m_minCalibTime
| private

Initial value:
{this, "minCalibTime", 0,
"Minimum number of milliseconds to do calibration"}

Definition at line 35 of file CPUCrunchSvc.h.

## ◆ m_niters_vect

Gaudi::Property<std::vector<unsigned int> > CPUCrunchSvc::m_niters_vect
| private

Initial value:
{
this, "NIterationsVect", {}, "Number of iterations for the calibration."}

Definition at line 32 of file CPUCrunchSvc.h.

## ◆ m_numCalibRuns

Gaudi::Property<int> CPUCrunchSvc::m_numCalibRuns {this, "numCalibRuns", 1, "Number of times to do calibration run"}
| private

Definition at line 37 of file CPUCrunchSvc.h.

## ◆ m_shortCalib

Gaudi::Property<bool> CPUCrunchSvc::m_shortCalib {this, "shortCalib", false, "Enable coarse grained calibration"}
| private

Definition at line 34 of file CPUCrunchSvc.h.

## ◆ m_times_vect

std::vector<unsigned int> CPUCrunchSvc::m_times_vect
| private

Definition at line 30 of file CPUCrunchSvc.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/CPUCrunchSvc/CPUCrunchSvc.h
- GaudiSvc/src/CPUCrunchSvc/CPUCrunchSvc.cpp